#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <ttt>

enum _:TTT_CHECKER
{
	TRIGGER_ENT,
	TRIGGER_NAME[32],
	DOOR_ENT,
	DOOR_NAME[32],
	LIGHT_ENT
}

new const g_iDoorStates[][] =
{
    {0, 2, 3, 1},
    {2, 0, 1, 3},
    {1, 3, 0, 2},
    {3, 1, 2, 0}
};

enum _:TOGGLE_STATE
{
    TS_AT_TOP,
    TS_AT_BOTTOM,
    TS_GOING_UP,
    TS_GOING_DOWN
}

new Array:g_aChecker;
new g_iTTTMap;
new g_iTriggeredCheck[33];

public plugin_precache()
{
	if(ttt_is_tttmap())
	{
		g_aChecker = ArrayCreate(TTT_CHECKER, 2);
		g_iTTTMap = true;
	}
}

public pfn_keyvalue(ent)
{
	if(!is_valid_ent(ent))
		return PLUGIN_CONTINUE;

	static classname[32], keyname[32], value[32];
	copy_keyvalue(classname, charsmax(classname), keyname, charsmax(keyname), value, charsmax(value));
	if(!equal(classname, "light"))
		return PLUGIN_CONTINUE;

	log_amx("class %s, keyname %s, value %s", classname, keyname, value);
	return PLUGIN_CONTINUE;
}

public plugin_init()
{
	register_plugin("[TTT] TTT map support", TTT_VERSION, TTT_AUTHOR);
	register_touch("trigger_multiple", "player", "Touch_TriggerMultiple");

	find_all_triggers();
}

public find_all_triggers()
{
	static array[TTT_CHECKER];
	new ent = -1, new_ent;
	while((ent = find_ent_by_class(ent, "trigger_multiple")) != 0)
	{
		if(is_valid_ent(ent))
		{
			entity_get_string(ent, EV_SZ_targetname, array[TRIGGER_NAME], charsmax(array[TRIGGER_NAME]));
			if(containi(array[TRIGGER_NAME], "ttt_checker") > -1)
			{
				new_ent = find_near_ents(ent, 1);
				if(is_valid_ent(new_ent))
					entity_get_string(new_ent, EV_SZ_targetname, array[DOOR_NAME], charsmax(array[DOOR_NAME]));
				array[DOOR_ENT] = new_ent;

				array[LIGHT_ENT] = find_near_ents(ent, 0);

				array[TRIGGER_ENT] = ent;
				ArrayPushArray(g_aChecker, array);
			}
		}
	}
}

public Touch_TriggerMultiple(ent, id)
{
	if(!is_valid_ent(ent) || !is_user_alive(id) || g_iTriggeredCheck[id])
		return;

	static index;
	if((index = in_array(ent)) > -1)
	{
		log_amx("ENT %d, id %d", ent, id);
		static array[TTT_CHECKER];
		ArrayGetArray(g_aChecker, index, array);
		close_doors(array[DOOR_ENT], TS_GOING_DOWN);

		g_iTriggeredCheck[id] = true;
	}
}

stock create_light(id)
{
	static value[32];
	new player_state = ttt_get_playerstate(id);
	formatex(value, charsmax(value), "%d %d %d 200",
		g_iTeamColors[player_state][0], g_iTeamColors[player_state][1], g_iTeamColors[player_state][2]);
	DispatchKeyValue(array[LIGHT_ENT], "_light", value);
	log_amx("value %s", value);
}

stock close_doors(ent, door_state)
{
	new end_state = g_iDoorStates[ExecuteHam(Ham_GetToggleState, ent)][door_state];

	for(new i = 1; i <= end_state; i++)
		call_think(ent);
} 

stock ttt_is_tttmap()
{
	static mapname[32];
	get_mapname(mapname, charsmax(mapname));

	if(equali(mapname, "ttt_", 4))
		return 1;

	return 0;
}

stock is_in_array(ent)
	return in_array(ent) > -1 ? true : false;

stock in_array(ent)
{
	static array[TTT_CHECKER];
	new size = ArraySize(g_aChecker);
	for(new i = 0; i < size; i++)
	{
		ArrayGetArray(g_aChecker, i, array);
		if(ent == array[TRIGGER_ENT])
			return i;
	}

	return -1;
}

stock find_near_ents(ent, val)
{
	static Float:origin[3], classname[32];
	entity_get_vector(ent, EV_VEC_origin, origin);
	new new_ent = -1;
	while((new_ent = find_ent_in_sphere(new_ent, origin, 500.0)) != 0)
	{
		if(is_valid_ent(new_ent))
		{
			entity_get_string(new_ent, EV_SZ_classname, classname, charsmax(classname));
			if(val)
			{
				if(equal(classname, "func_door") || equal(classname, "func_door_rotating"))
					return new_ent;
			}
			else
			{
				if(equal(classname, "light"))
					return new_ent;
			}
		}
	}

	return 0;
}